]> git.immae.eu Git - perso/Immae/Config/Nix.git/blobdiff - nixops/scripts/setup
Adjust setup script
[perso/Immae/Config/Nix.git] / nixops / scripts / setup
index 758cc34e584f7b00a0f49c1d6590e4351781f0b8..9bdb8df2c684339f8240698f3af36c4500b79caf 100755 (executable)
@@ -1,9 +1,6 @@
-#!/bin/bash
+#!/usr/bin/env bash
 
-set -euxo pipefail
-
-RemoteRepo="gitolite@git.immae.eu:perso/Immae/Prive/Password_store/Sites"
-DeploymentUuid="cef694f3-081d-11e9-b31f-0242ec186adf"
+set -euo pipefail
 
 if ! which nix 2>/dev/null >/dev/null; then
   cat <<-EOF
@@ -14,113 +11,82 @@ if ! which nix 2>/dev/null >/dev/null; then
   exit 1
 fi
 
-if [ -z "$NIXOPS_CONFIG_PASS_SUBTREE_REMOTE" \
-    -o -z "$NIXOPS_CONFIG_PASS_SUBTREE_PATH" ]; then
+if [ "${NIX_STORE:-/nix/store}" != "/nix/store" ]; then
   cat <<-EOF
-       Two environment variables are needed to setup the password store:
-       NIXOPS_CONFIG_PASS_SUBTREE_PATH : path where the subtree will be imported
-       NIXOPS_CONFIG_PASS_SUBTREE_REMOTE : remote name to give to the repository
+       Nix store outside of /nix/store is not supported
        EOF
   exit 1
 fi
 
-if ! pass $NIXOPS_CONFIG_PASS_SUBTREE_PATH > /dev/null 2>/dev/null; then
+if ! which direnv 2>/dev/null >/dev/null; then
   cat <<-EOF
-       /!\ This will modify your password store to add and import a subtree
-       with the specific passwords files. Choose a path that doesn’t exist
-       yet in your password store.
-       > pass git remote add $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE $RemoteRepo
-       > pass git subtree add --prefix=$NIXOPS_CONFIG_PASS_SUBTREE_PATH $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE master
-       Later, you can use pull_environment and push_environment scripts to
-       update the passwords when needed
-       Continue? [y/N]
+       direnv is needed, please install it
        EOF
-  read y
-  if [ "$y" = "y" -o "$y" = "Y" ]; then
-    pass git remote add $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE $RemoteRepo
-    pass git subtree add --prefix=$NIXOPS_CONFIG_PASS_SUBTREE_PATH $NIXOPS_CONFIG_PASS_SUBTREE_REMOTE master
-  else
-    echo "Aborting"
-    exit 1
-  fi
+  exit 1
 fi
 
-if [ ! -f /etc/ssh/ssh_rsa_key_nixops ]; then
+if [ -z "$NIXOPS_ENV_LOADED" ]; then
   cat <<-EOF
-       The key to access private git repositories (websites hosted by the
-       server) needs to be accessible to nix builders. It will be put in
-       /etc/ssh/ssh_rsa_key_nixops (sudo right is needed for that)
-       > pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/SshKey | sudo tee /etc/ssh/ssh_rsa_key_nixops > /dev/null
-       > pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/SshKey.pub | sudo tee /etc/ssh/ssh_rsa_key_nixops.pub > /dev/null
-       > sudo chmod u=r,go-rwx /etc/ssh/ssh_rsa_key_nixops
-       > sudo chown nixbld1:nixbld /etc/ssh/ssh_rsa_key_nixops /etc/ssh/ssh_rsa_key_nixops.pub
-       Continue? [y/N]
+       direnv environment needs to be loaded
        EOF
-  read y
-  if [ "$y" = "y" -o "$y" = "Y" ]; then
-    if ! id -u nixbld1 2>/dev/null >/dev/null; then
-      echo "User nixbld1 seems inexistant, did you install nix?"
-      exit 1
-    fi
-    mask=$(umask)
-    umask 0777
-    # Don’t forward it directly to tee, it would break ncurse pinentry
-    key=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/SshKey)
-    echo "$key" | sudo tee /etc/ssh/ssh_rsa_key_nixops > /dev/null
-    sudo chmod u=r,go=- /etc/ssh/ssh_rsa_key_nixops
-    pubkey=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/SshKey.pub)
-    echo "$pubkey" | sudo tee /etc/ssh/ssh_rsa_key_nixops.pub > /dev/null
-    sudo chmod a=r /etc/ssh/ssh_rsa_key_nixops.pub
-    sudo chown nixbld1:nixbld /etc/ssh/ssh_rsa_key_nixops /etc/ssh/ssh_rsa_key_nixops.pub
-    umask $mask
-  else
-    echo "Aborting"
-    exit 1
-  fi
+  exit 1
 fi
 
-if ! which nixops 2>/dev/null >/dev/null; then
+if [ "$(git config --get include.path)" != "../.gitconfig" ]; then
   cat <<-EOF
-       nixops is needed:
-       > nix-env -i nixops
-       If it fails, please check that $HOME/.nix-profile/bin is in your PATH.
-       Continue? [y/N]
+       it is recommended to include the .gitconfig file into (local) git configuration:
+       git config --local include.path '../.gitconfig'
+       Run this command? [y/N]
        EOF
   read y
   if [ "$y" = "y" -o "$y" = "Y" ]; then
-    nix-env -i nixops
-    if ! which nixops 2>/dev/null >/dev/null; then
-      echo "Installation failed, please check that $HOME/.nix-profile/bin is in your path."
-      exit 1
-    fi
-  else
-    echo "Aborting"
-    exit 1
+    git config --local include.path '../.gitconfig'
   fi
 fi
 
-DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
-export NIXOPS_STATE="$(dirname $DIR)/state/eldiron.nixops"
-export NIXOPS_DEPLOYMENT="$DeploymentUuid"
+gpg_keys=$(pass ls Nixops/GPGKeys | sed -e "1d" | cut -d" " -f2)
+for key in $gpg_keys; do
+  content=$(pass show Nixops/GPGKeys/$key)
+  fpr=$(echo "$content" | gpg --import-options show-only --import --with-colons | grep -e "^pub" | cut -d':' -f5)
+  gpg --list-key "$fpr" >/dev/null 2>/dev/null && imported=yes || imported=no
+  # /usr/share/doc/gnupg/DETAILS field 2
+  (echo "$content" | gpg --import-options show-only --import --with-colons |
+      grep -E '^pub:' |
+      cut -d':' -f2 |
+      grep -q '[fu]') && signed=yes || signed=no
+  if [ "$signed" = no -o "$imported" = no ] ; then
+    echo "The key for $key needs to be imported and signed (a local signature is enough)"
+    echo "$content" | gpg --import-options show-only --import
+    echo "Continue? [y/N]"
+    read y
+    if [ "$y" = "y" -o "$y" = "Y" ]; then
+      echo "$content" | gpg --import
+      gpg --expert --edit-key "$fpr" lsign quit
+    else
+      echo "Aborting"
+      exit 1
+    fi
+  fi
+done
 
-if ! nixops info 2>/dev/null >/dev/null; then
+if nix show-config --json | jq -e '.sandbox.value == "true"' >/dev/null; then
   cat <<-EOF
-       Importing deployment file into nixops:
-       Continue? [y/N]
+       There used to be some impure derivations (grep __noChroot), you may need
+         sandbox = "relaxed"
+       in /etc/nix/nix.conf
+       you may also want to add
+         keep-outputs = true
+         keep-derivations = true
+       to prevent garbage collector from deleting build dependencies (they take a lot of time to build)
+        and
+         allow-import-from-derivation = false
+       as an attempt to avoid having build-time derivations (doesn’t work for all packages)
+       press key to continue
        EOF
   read y
-  if [ "$y" = "y" -o "$y" = "Y" ]; then
-    deployment=$(pass show $NIXOPS_CONFIG_PASS_SUBTREE_PATH/Nixops/Deployment)
-    echo "$deployment" | nixops import
-
-    nixops modify "$(dirname $DIR)/eldiron.nix"
-  else
-    echo "Aborting"
-    exit 1
-  fi
 fi
 
 cat <<-EOF
        All set up.
-       Please make sure you’re using scripts/nixops_wrap when deploying
+       Please make sure you’re using make commands when deploying
        EOF